% synt3.m - synteza klikoveho mechanismu pro 3 predepsane polohy
clear all; close all; clc

% predepsane polohy
fi1=30*pi/180; s1=1.2;
fi2=45*pi/180; s2=1;
fi3=60*pi/180; s3=0.72;

A=[s1*cos(fi1) sin(fi1) 1;
   s2*cos(fi2) sin(fi2) 1;
   s3*cos(fi3) sin(fi3) 1];

b=[s1^2;
   s2^2;
   s3^2];

x=inv(A)*b; % x=[k;l;m]

r=x(1)/2
e=x(2)/(2*r)
d=sqrt(x(3)+r^2+e^2)

% animace
fi=20*pi/180:0.01:80*pi/180;
for i=1:length(fi)
    xA=r*cos(fi(i));
    yA=r*sin(fi(i));
    yB=e;
    xB=xA+sqrt(d^2-(yA-e)^2);
    plot(xB,yB,'bs-','linewidth',5); hold on
    plot([0,xA,xB],[0,yA,yB],'ro-','linewidth',2); hold off
    axis([-0.2 1.4 -0.2 1.4])
    grid on
    drawnow
end

% vykresleni odchylek
s1real=r*cos(fi1)+sqrt(d^2-(r*sin(fi1)-e)^2);
s2real=r*cos(fi2)+sqrt(d^2-(r*sin(fi2)-e)^2);
s3real=r*cos(fi3)+sqrt(d^2-(r*sin(fi3)-e)^2);
figure
plot([fi1,fi2,fi3],[s1,s2,s3],'ro',[fi1,fi2,fi3],[s1real,s2real,s3real],'bx','linewidth',2);
legend('Predepsane','Dosazene')
title('Predepsane a dosazene polohy');xlabel('poloha bodu B');ylabel('uhel fi')
axis([0 pi/2 -0.2 1.4]);grid on












