% synt5.m - synteza klikoveho mechanismu pro 5 predepsanych poloh
% pouziti pseudoinverze zarucuje splneni s nejmensim souctem ctvercu odchylek
clear all; close all; clc

% predepsane polohy
fi=[30,45,60,40,20]*pi/180;
s=[1.2,1,0.72,1.05,1.25];

A=[];
b=[];
for i=1:length(fi)
    A=[A;
       s(i)*cos(fi(i)) sin(fi(i)) 1];
    b=[b;
       s(i)^2];
end

% Pseudoinverze
x=inv(A'*A)*A'*b; % x=[k;l;m]

r=x(1)/2
e=x(2)/(2*r)
d=sqrt(x(3)+r^2+e^2)

% vykresleni odchylek
sreal=r*cos(fi)+sqrt(d^2-(r*sin(fi)-e).^2);
figure
plot([fi],[s],'ro',[fi],[sreal],'bx','linewidth',2);
legend('Predepsane','Dosazene')
title('Predepsane a dosazene polohy');xlabel('poloha bodu B');ylabel('uhel fi')
axis([0 pi/2 -0.2 1.4]);grid on

% animace
figure
fi=20*pi/180:0.01:80*pi/180;
for i=1:length(fi)
    xA=r*cos(fi(i));
    yA=r*sin(fi(i));
    yB=e;
    xB=xA+sqrt(d^2-(yA-e)^2);
    plot(xB,yB,'bs-','linewidth',5); hold on
    plot([0,xA,xB],[0,yA,yB],'ro-','linewidth',2); hold off
    axis([-0.2 1.4 -0.2 1.4])
    grid on
    drawnow
end
odchylka =(sreal-s)*(sreal-s)'













